diff --git a/subsys/net/ip/ipv6.c b/subsys/net/ip/ipv6.c
index 012e62afb6b7..a72b7132d5fc 100644
--- a/subsys/net/ip/ipv6.c
+++ b/subsys/net/ip/ipv6.c
@@ -117,6 +117,7 @@ int net_ipv6_finalize(struct net_pkt *pkt, u8_t next_header_proto)
 			return -EINVAL;
 		}
 	}
+
 #endif
 	net_pkt_compact(pkt);
 
@@ -452,6 +453,12 @@ enum net_verdict net_ipv6_process_pkt(struct net_pkt *pkt)
 		goto drop;
 	}
 
+	/* Check extension headers */
+	net_pkt_set_next_hdr(pkt, &hdr->nexthdr);
+	net_pkt_set_ipv6_ext_len(pkt, 0);
+	net_pkt_set_ip_hdr_len(pkt, sizeof(struct net_ipv6_hdr));
+	net_pkt_set_ipv6_hop_limit(pkt, NET_IPV6_HDR(pkt)->hop_limit);
+
 	if (!net_is_my_ipv6_addr(&hdr->dst) &&
 	    !net_is_my_ipv6_maddr(&hdr->dst) &&
 	    !net_is_ipv6_addr_mcast(&hdr->dst) &&
@@ -486,12 +493,6 @@ enum net_verdict net_ipv6_process_pkt(struct net_pkt *pkt)
 		goto drop;
 	}
 
-	/* Check extension headers */
-	net_pkt_set_next_hdr(pkt, &hdr->nexthdr);
-	net_pkt_set_ipv6_ext_len(pkt, 0);
-	net_pkt_set_ip_hdr_len(pkt, sizeof(struct net_ipv6_hdr));
-	net_pkt_set_ipv6_hop_limit(pkt, NET_IPV6_HDR(pkt)->hop_limit);
-
 	/* Fast path for main upper layer protocols. The handling of extension
 	 * headers can be slow so do this checking here. There cannot
 	 * be any extension headers after the upper layer protocol header.
